Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Reactor_Notify Class Reference

Abstract class for unblocking an <ACE_Reactor_Impl> from its event loop. More...

`#include <Reactor_Impl.h>`

Inheritance diagram for ACE_Reactor_Notify:

[legend]
Collaboration diagram for ACE_Reactor_Notify:

[legend]
List of all members.

## Public Methods
virtual int | open (ACE_Reactor_Impl *, ACE_Timer_Queue *timer_queue=0, int disable_notify=0)=0
virtual int | close (void)=0
virtual int | notify (ACE_Event_Handler *=0, ACE_Reactor_Mask=ACE_Event_Handler::EXCEPT_MASK, ACE_Time_Value *=0)=0
| Called by a thread when it wants to unblock the <Reactor_Impl>. More...
virtual int | dispatch_notifications (int &number_of_active_handles, ACE_Handle_Set &rd_mask)=0
| Handles pending threads (if any) that are waiting to unblock the <Reactor_Impl>. More...
virtual ACE_HANDLE | notify_handle (void)=0
| Returns the ACE_HANDLE of the notify pipe on which the reactor is listening for notifications so that other threads can unblock the <Reactor_Impl>. More...
virtual int | is_dispatchable (ACE_Notification_Buffer &buffer)=0
| Verify whether the buffer has dispatchable info or not. More...
virtual int | dispatch_notify (ACE_Notification_Buffer &buffer)=0
| Handle one of the notify call on the <handle>. This could be because of a thread trying to unblock the <Reactor_Impl>. More...
virtual int | read_notify_pipe (ACE_HANDLE handle, ACE_Notification_Buffer &buffer)=0
| Read one of the notify call on the <handle> into the <buffer>. This could be because of a thread trying to unblock the <Reactor_Impl>. More...
virtual void | max_notify_iterations (int)=0
| Set the maximum number of times that the <handle_input> method will iterate and dispatch the <ACE_Event_Handlers> that are passed in via the notify queue before breaking out of the event loop. More...
virtual int | max_notify_iterations (void)=0
| Get the maximum number of times that the <handle_input> method will iterate and dispatch the <ACE_Event_Handlers> that are passed in via the notify queue before breaking out of its event loop. More...
virtual int | purge_pending_notifications (ACE_Event_Handler *=0, ACE_Reactor_Mask=ACE_Event_Handler::ALL_EVENTS_MASK)=0
| Purge any notifications pending in this reactor for the specified <ACE_Event_Handler> object. More...
virtual void | dump (void) const=0
| Dump the state of an object. More...

## Detailed Description

Abstract class for unblocking an <ACE_Reactor_Impl> from its event loop.

## Member Function Documentation

virtual int ACE_Reactor_Notify::close | ( | void |  | ) | `[pure virtual]`

| Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual int ACE_Reactor_Notify::dispatch_notifications | ( | int & | number_of_active_handles,
|  | ACE_Handle_Set & | rd_mask
| ) | `[pure virtual]`

| Handles pending threads (if any) that are waiting to unblock the <Reactor_Impl>. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual int ACE_Reactor_Notify::dispatch_notify | ( | ACE_Notification_Buffer & | buffer | ) | `[pure virtual]`

| Handle one of the notify call on the <handle>. This could be because of a thread trying to unblock the <Reactor_Impl>. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual void ACE_Reactor_Notify::dump | ( | void |  | ) | const`[pure virtual]`

| Dump the state of an object. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual int ACE_Reactor_Notify::is_dispatchable | ( | ACE_Notification_Buffer & | buffer | ) | `[pure virtual]`

| Verify whether the buffer has dispatchable info or not. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual int ACE_Reactor_Notify::max_notify_iterations | ( | void |  | ) | `[pure virtual]`

| Get the maximum number of times that the <handle_input> method will iterate and dispatch the <ACE_Event_Handlers> that are passed in via the notify queue before breaking out of its event loop. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual void ACE_Reactor_Notify::max_notify_iterations | ( | int | iterations | ) | `[pure virtual]`

| Set the maximum number of times that the <handle_input> method will iterate and dispatch the <ACE_Event_Handlers> that are passed in via the notify queue before breaking out of the event loop. By default, this is set to -1, which means "iterate until the queue is empty." Setting this to a value like "1 or 2" will increase "fairness" (and thus prevent starvation) at the expense of slightly higher dispatching overhead. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual int ACE_Reactor_Notify::notify | ( | ACE_Event_Handler * | eh = 0,
|  | ACE_Reactor_Mask | mask = ACE_Event_Handler::EXCEPT_MASK,
|  | ACE_Time_Value * | timeout = 0
| ) | `[pure virtual]`

| Called by a thread when it wants to unblock the <Reactor_Impl>. This wakeups the <Reactor_Impl> if currently blocked. Pass over both the <Event_Handler> *and* the <mask> to allow the caller to dictate which <Event_Handler> method the <Reactor_Impl> will invoke. The <ACE_Time_Value> indicates how long to blocking trying to notify the <Reactor_Impl>. If <timeout> == 0, the caller will block until action is possible, else will wait until the relative time specified in *<timeout> elapses). Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual ACE_HANDLE ACE_Reactor_Notify::notify_handle | ( | void |  | ) | `[pure virtual]`

| Returns the ACE_HANDLE of the notify pipe on which the reactor is listening for notifications so that other threads can unblock the <Reactor_Impl>. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual int ACE_Reactor_Notify::open | ( | ACE_Reactor_Impl * | wfmo_reactor,
|  | ACE_Timer_Queue * | timer_queue = 0,
|  | int | ignore_notify = 0
| ) | `[pure virtual]`

| Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual int ACE_Reactor_Notify::purge_pending_notifications | ( | ACE_Event_Handler * | eh = 0,
|  | ACE_Reactor_Mask | mask = ACE_Event_Handler::ALL_EVENTS_MASK
| ) | `[pure virtual]`

| Purge any notifications pending in this reactor for the specified <ACE_Event_Handler> object. Returns the number of notifications purged. Returns -1 on error. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

virtual int ACE_Reactor_Notify::read_notify_pipe | ( | ACE_HANDLE | handle,
|  | ACE_Notification_Buffer & | buffer
| ) | `[pure virtual]`

| Read one of the notify call on the <handle> into the <buffer>. This could be because of a thread trying to unblock the <Reactor_Impl>. Reimplemented in ACE_Dev_Poll_Reactor_Notify, ACE_Select_Reactor_Notify, and ACE_WFMO_Reactor_Notify.

The documentation for this class was generated from the following file:

- Reactor_Impl.h